import * as i0 from '@angular/core';
import { Injectable, Input, Directive, NgModule, inject } from '@angular/core';
import { getOr } from 'lodash/fp';
import { Observable } from 'rxjs';
import * as i1 from '@progress-chef/platform-shared-store';
import { Router } from '@angular/router';
import { map } from 'rxjs/operators';

class FeatureFlagsService {
    constructor(chefPlatformExperienceFeatureSharedFacadeService) {
        this.chefPlatformExperienceFeatureSharedFacadeService = chefPlatformExperienceFeatureSharedFacadeService;
    }
    featureGetFeatureFlags(payload) {
        this.chefPlatformExperienceFeatureSharedFacadeService.featureGetFeatureFlags(payload);
    }
    isFeatureEnabled(searchPattern) {
        return new Observable(observer => {
            this.chefPlatformExperienceFeatureSharedFacadeService.featureGetFeatureFlags$().subscribe((featureList) => {
                observer.next(getOr(false)(searchPattern + '.allowed')(featureList?.details));
            });
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsService, deps: [{ token: i1.ChefPlatformExperienceFeatureSharedFacadeService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i1.ChefPlatformExperienceFeatureSharedFacadeService }] });

class FeatureFlagsDirective {
    constructor(templateRef, container, featureFlagsService) {
        this.templateRef = templateRef;
        this.container = container;
        this.featureFlagsService = featureFlagsService;
        this.searchPattern = "";
    }
    ngOnInit() {
        this.featureFlagsService.isFeatureEnabled(this.searchPattern).subscribe((isFeatureEnabled) => {
            if (!isFeatureEnabled) {
                this.container.clear();
            }
            else {
                this.container.createEmbeddedView(this.templateRef);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }, { token: FeatureFlagsService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.3.12", type: FeatureFlagsDirective, selector: "[appFeatureFlag]", inputs: { searchPattern: ["appFeatureFlag", "searchPattern"] }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[appFeatureFlag]'
                }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }, { type: FeatureFlagsService }], propDecorators: { searchPattern: [{
                type: Input,
                args: ['appFeatureFlag']
            }] } });

class FeatureFlagsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsModule, declarations: [FeatureFlagsDirective], exports: [FeatureFlagsDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsModule, providers: [FeatureFlagsService] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: FeatureFlagsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [],
                    declarations: [FeatureFlagsDirective],
                    providers: [FeatureFlagsService],
                    exports: [FeatureFlagsDirective]
                }]
        }] });

const canActivateFeatureGuard = (route) => {
    const router = inject(Router);
    const featureFlagsService = inject(FeatureFlagsService);
    return featureFlagsService.isFeatureEnabled(route.data ? route.data['feature'] : null).pipe(map((isFeatureEnabled) => {
        if (isFeatureEnabled) {
            return true;
        }
        else {
            router.navigate(['/hub']);
            return false;
        }
    }));
};

/*
 * Public API Surface of platform-feature-flags-service
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FeatureFlagsDirective, FeatureFlagsModule, FeatureFlagsService, canActivateFeatureGuard };
//# sourceMappingURL=progress-chef-platform-feature-flags-service.mjs.map
